<?php
/**
* © Copyright 2008 IntraHealth International, Inc.
*
* This File is part of I2CE
*
* I2CE is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/**
*  Ngorongoro_Module_Trainng
* @package I2CE
* @subpackage Core
* @author Ally Shaban <allyshaban5@gmail.com>
* @copyright Copyright &copy; 2008 IntraHealth International, Inc.
* This file is part of I2CE. I2CE is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version. I2CE is distributed in the hope
* that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
* or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have
* received a copy of the GNU General Public License along with this program. If not, see <http://www.gnu.org/licenses/>.
* @version 2.1
* @access public
*/


class Ngorongoro_Module_Appreciation extends I2CE_Module{

    public static function getMethods() {
        return array(
            'iHRIS_PageView->action_appreciation' => 'action_appreciation',
            );
    }

    public static function getHooks() {
      return array(
              'validate_form_appreciation' => 'validate_form_appreciation',
              );
    }


    public function action_appreciation($page) {
        if (!$page instanceof iHRIS_PageView) {
            return false;
        }
        return $page->addChildForms('appreciation','siteContent');
    }

    public function validate_form_appreciation( $form ) {
      if ( $form->appreciation_date->isValid()) {
        if ( $form->appreciation_date->compare(I2CE_Date::now()) < 0 ) {
          $form->setInvalidMessage('appreciation_date','Appreciation Date Should No Be Greater Than Today');
        }
      }
    }

}
# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
