<?php
/**
* © Copyright 2009 IntraHealth International, Inc.
*
* This File is part of I2CE
*
* I2CE is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 3 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program.  If not, see <http://www.gnu.org/licenses/>.
* @package iHRIS
* @subpackage Manage
* @author Carl Leitner <litlfred@ibiblio.org>
* @version v3.2.6
* @since v3.2.6
* @filesource
*/
/**
*
* @access public
*/


class iHRIS_Module_ngorongoroPersonPosition extends iHRIS_Module_PersonPosition {


	//static function getMethods() {
        //return array( 'iHRIS_PageView->action_person_position'
        //        => 'action_person_position' );
  //  }


    /**
     * Return the array of hooks available in this module.
     * @return array
     */
    public static function getHooks() {
        return array(
                'validate_form_person_position' => 'validate_form_person_position',
                'validate_form_position' => 'validate_form_position'
                );
    }

    /**
     * Checks to make sure the end date is after the start date for the person position.
     * @param I2CE_Form $form
     */
    public function validate_form_person_position( $form ) {
/*
        if ( $form->start_date->isValid() && $form->decision_date->isValid() ) {
            if ( $form->start_date->compare( $form->decision_date ) > 1 ) {
                $form->setInvalidMessage('decision_date','bad_date');
            }
        }
*/
     }

     public function validate_form_position( $form ) {
       $department = implode("|",$form->department);
       $unit = implode("|",$form->unit);
       if($unit == "|" and $department == "|") {
         $form->setInvalidMessage('department','A staff must be attached to either department or Unit');
         $form->setInvalidMessage('unit','A staff must be attached to either department or Unit');
       }
       if($unit !="|" and $department !="|") {
         $form->setInvalidMessage('department','A staff cant be attached to both departments and Unit,attach to only one');
         $form->setInvalidMessage('unit','A staff cant be attached to both departments and Unit,attach to only one');
       }
      }



}


# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
