#!/usr/bin/php
<?php
/*
 * © Copyright 2007, 2008 IntraHealth International, Inc.
 * 
 * This File is part of iHRIS
 * 
 * iHRIS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/**
 * The page wrangler
 * 
 * This page loads the main HTML template for the home page of the site.
 * @package iHRIS
 * @subpackage DemoManage
 * @access public

 * @copyright Copyright &copy; 2007, 2008-2013 IntraHealth International, Inc. 
 * @version 4.6.0
 */

require_once("./import_base.php");

class Data_Import3 extends Processor{
    
    public function __construct($file) {
        parent::__construct($file);
    }
    
    //map headers from the spreadsheet
    //what you do here is change the values on the right to match what you have on the spreadsheet. comment out lines that are not in the spreadsheet
    //the values of the left are used by the script to refer to the spreadsheet columns on the right of this array.
    //the order of the columns in the spreadsheet doesn't matter
    
    protected function getExpectedHeaders(){
        return array(
          'kabila' => 'Tribe');
      }

    protected static $required_cols_by_transaction = array(
        'NE'=>array('kabila')
        );

   protected function _processRow() {
      $success = true;
      $this->create_tribe();
      return $success;
      }

    protected function create_tribe() {
    	$kabila = trim(ucwords($this->mapped_data["kabila"]));
    	$kabila_id = $this->search_data("tribe",$kabila,"name");
    	if(!$kabila_id){
    	$tribeObj = $this->ff->createContainer('tribe');
    	$tribeObj->getField("name")->setValue($kabila);
    	$kabila =$this->add_magicdata("tribe",$kabila);
        $id = $this->save($tribeObj);
    	//return "tribe|".$id;
    }
}

 /**   //you need to add logic on this function,it just need to add job into job form,make sure that it first check if a job exists
    protected function create_job($job) {
    	$cadre = trim(ucwords($this->mapped_data["cadre"]));
    	$jobObj = $this->ff->createContainer('job');
    	$jobObj->getField("title")->setValue($job);
    	$cadre =$this->add_magicdata("cadre",$cadre);
    	$jobObj->getField("cadre")->setFromDB($cadre);
    	$id = $this->save($jobObj);
    	return "job|".$id;
    }

    protected function create_facility($facility) {
    	$ftype = trim(ucwords($this->mapped_data["ftype"]));
    	$ftype = $this->add_magicdata("facility_type",$ftype);
    	$fowner = trim(ucwords($this->mapped_data["fowner"]));
    	$fowner = $this->add_magicdata("facility_ownership",$fowner);
    	$facObj = $this->ff->createContainer('facility');
    	$facObj->getField("name")->setValue($facility);
    	$facObj->getField("facility_type")->setFromDB($ftype);
    	$facObj->getField("facility_ownership")->setFromDB($fowner);
    	$id = $this->save($facObj);
    	return "facility|".$id;
    }
		
	
**/
    protected function search_data($form,$data,$field) {
			$where=array(	"operator"=>"FIELD_LIMIT",
										"field"=>$field,
										"style"=>"equals",
										"data"=>array("value"=>$data)
									 );
			$exist=I2CE_FormStorage::search($form,false,$where);
			if(count($exist)==0) {
				return false;
			}
			else {
				return $form."|".$exist[0];
			}
		}

	protected function add_magicdata($form,$data,$field=false,$mapped_data=array()) {
		if(!$field)
		$field="name";
		$where=array(	"operator"=>"FIELD_LIMIT",
							"field"=>$field,
							"style"=>"equals",
							"data"=>array("value"=>$data)
						 );
		$exist=I2CE_FormStorage::search($form,false,$where);
		if(count($exist)==0) {
			$formObj=$this->ff->createContainer($form);
			$formObj->getField($field)->setValue($data);
			if(count($mapped_data)>0) {
				$formObj->getField($mapped_data["form"])->setFromDB($mapped_data["data"]);
			}
			$data_id=$this->save($formObj);
			return $form."|".$data_id;
			}
		else {
			return $form."|".$exist[0];
			}
		}


}


/*********************************************
*
*      Execute!
*
*********************************************/

//ini_set('memory_limit','3000MB');


if (count($arg_files) != 1) {
    usage("Please specify the name of a spreadsheet to process");
}

reset($arg_files);
$file = current($arg_files);
if($file[0] == '/') {
    $file = realpath($file);
} else {
    $file = realpath($dir. '/' . $file);
}
if (!is_readable($file)) {
    usage("Please specify the name of a spreadsheet to import: " . $file . " is not readable");
}

I2CE::raiseMessage("Loading from $file");


$processor = new Data_Import3($file);
$processor->run();

echo "Processing Statistics:\n";
print_r( $processor->getStats());




# Local Variables:
# mode: php
# c-default-style: "bsd"
# indent-tabs-mode: nil
# c-basic-offset: 4
# End:
